(*
**
** COUNTRY.INC, Country information support file
**
** Copyright (c) 1996 by Maarten Bekers
**
** Created : 03-May-1996
** Last update : 03-May-1996
**
**
*)

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetActiveCodePage: String;
Var Temp: String;
Begin;
 Temp := '';

 Regs.AX := $6601;
 Intr($21, Regs);

 If Regs.AL=$01 then
  Begin;
   Temp := '('+FStr(Regs.BX)+')';
   Case Regs.BX of
    437 : Temp := Temp + ' (US)';
    850 : Temp := Temp + ' (Multilingual)';
    852 : Temp := Temp + ' (Slavic/Latin II)';
    857 : Temp := Temp + ' (Turkish)';
    860 : Temp := Temp + ' (Portugal)';
    861 : Temp := Temp + ' (Iceland)';
    863 : Temp := Temp + ' (Canada (French))';
    865 : Temp := Temp + ' (Norway/Denmark)';
   End; { Case }
 End; { If }
 GetActiveCodePage := Temp;
End; { func. GetActiveCodePage }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetDefaultCodePage: String;
Var Temp: String;
Begin;
 Temp := '';

 Regs.AX := $6601;
 Intr($21, Regs);

 If Regs.AL=$01 then
  Begin;
   Temp := '('+FStr(Regs.DX)+')';
   Case Regs.DX of
    437 : Temp := Temp + ' (US)';
    850 : Temp := Temp + ' (Multilingual)';
    852 : Temp := Temp + ' (Slavic/Latin II)';
    857 : Temp := Temp + ' (Turkish)';
    860 : Temp := Temp + ' (Portugal)';
    861 : Temp := Temp + ' (Iceland)';
    863 : Temp := Temp + ' (Canada (French))';
    865 : Temp := Temp + ' (Norway/Denmark)';
   End; { Case }
 End; { If }
 GetDefaultCodePage := Temp;
End; { func. GetDefaultCodePage }


(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetCountryCode: Byte;
Begin;
  Regs.AH := $38;
  Regs.AL := $00;
  Regs.DS := 00;
  Regs.DX := 00;
  Intr($21, Regs);
  GetCountryCode := Regs.BX;
End; { func. GetCountryCode }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetCountryName: String;
Begin;
 Regs.AH := $38;
 Regs.AL := $00;
 Regs.DS := 00;
 Regs.DX := 00;
 Intr($21, Regs);

 GetCountryName := '(unknown)';

 Case Regs.BX of
   $001 : GetCountryName := 'United States';
   $002 : GetCountryName := 'Canadian-French';
   $003 : GetCountryName := 'Latin America';
   $01F : GetCountryName := 'The Netherlands';
   $020 : GetCountryName := 'Belgium';
   $021 : GetCountryName := 'France';
   $022 : GetCountryName := 'Spain';
   $024 : GetCountryName := 'Hungary';
   $026 : GetCountryName := 'Yugoslavia';
   $027 : GetCountryName := 'Italy';
   $029 : GetCountryName := 'Switzerland';
   $02A : GetCountryName := 'Czechoslovakia/Tjekia';
   $02B : GetCountryName := 'Austria';
   $02C : GetCountryName := 'United Kingdom';
   $02D : GetCountryName := 'Denmark';
   $02E : GetCountryName := 'Sweden';
   $02F : GetCountryName := 'Norway';
   $030 : GetCountryName := 'Poland (not supported by DR-DOS 5.0)';
   $031 : GetCountryName := 'Germany';
   $037 : GetCountryName := 'Brazil';
   $03D : GetCountryName := 'International English (Australia)';
   $051 : GetCountryName := 'Japan';
   $052 : GetCountryName := 'Korea';
   $056 : GetCountryName := 'China';
   $058 : GetCountryName := 'Taiwan';
   $05A : GetCountryName := 'Turkey';
   $15F : GetCountryName := 'Portugal';
   $162 : GetCountryName := 'Iceland';
   $166 : GetCountryName := 'Finland';
   $311 : GetCountryName := 'Middle East/Saudi Ariaba';
   $3CC : GetCountryName := 'Israel';
 End; { Case }
End; { GetCountryName }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetDateFormat: String;
Var SepChar: Char;
Begin;
 SepChar := Country.Datesep[0];
 GetDateFormat := '(unknown)';
 Case Country.DateFormat of
  00 : GetDateFormat := 'USA (mm'+SepChar+'dd'+SepChar+'yy)';
  01 : GetDateFormat := 'Europe (dd'+SepChar+'mm'+SepChar+'yy)';
  02 : GetDateFormat := 'Japan (yy'+SepChar+'mm'+SepChar+'dd)';
 End;
End; { func. GetDateFormat }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetTimeFormat: String;
Var SepChar: Char;
Begin;
 If ReadBit(Country.TimeFormat, 1) then GetTimeFormat := '12-Hour'
  else GetTimeFormat := '24-Hour';
End; { func. GetTimeFormat }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GetCurrencyFormat: String;
Begin;
 GetCurrencyFormat := 'x'+Country.Thousands[0]+'xxx'+Country.Decimal[0]+
                      Dup('x', Country.Digits);
End; { func. GetCurrencyFormat }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure ShowCountryInfo;
Begin;
 Writeln('Global code page (active)          : ',GetActiveCodePage);
 Writeln('Global code page (default)         : ',GetDefaultCodePage);
 Writeln('Country code / name                : ',GetCountrycode, ' / ',
GetCountryName);
 Writeln('Thousands seperator character     : ',Country.Thousands[0]);
 Writeln('Decimal seperator character       : ',Country.Decimal[0]);
 Writeln('Datalist seperator character      : ',Country.Datalist[0]);
 Writeln('DateFormat                        : ',GetDateFormat);
 Writeln('TimeFormat                        : ',GetTimeFormat);
 Writeln('Currency Format                   : ',GetCurrencyFormat);
End; { proc. ShowCountryInfo }
