(*
**
** DATA.INC, Data declerations for SYSINFO.
**
** Copyright (c) 1996 by Maarten Bekers
**
** Created : 29-Apr-1996
** Last update : 29-Apr-1996
**
**
*)

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Type  CountryRec = Record
                     DateFormat   : Word;
                     CurrencyChar : Array[0..4] of Char;
                     Thousands    : Array[0..1] Of Char;
                     Decimal      : Array[0..1] Of Char;
                     DateSep      : Array[0..1] Of Char;
                     TimeSep      : Array[0..1] Of Char;
                     Currency     : Byte;
                     Digits       : Byte;
                     TimeFormat   : Byte;
                     UpperCase    : Pointer;
                     DataList     : Array[0..1] of Char;
                     Reserved     : Array[1..10] Of Byte;
                   End; { CountryRec }

Type  CMOSMemRec = Record
                     ClockRegs       : Array[1..14] Of Byte;
                     Diagnostic      : Byte;
                     ShutdownStatus  : Byte;
                     FloppyDriveType : Byte;
                     Reserved1       : Byte;
                     FixedDriveType  : Byte;
                     Reserved2       : Byte;
                     EquipmentType   : Byte;
                     BaseMemory      : Integer;
                     ExtendedMemory1 : Integer;
                     Reserved3       : Array[1..21] Of Byte;
                     CheckSum        : Integer;
                     ExtendedMemory2 : Integer;
                     CenturyDate     : Byte;
                     InfoFlag        : Byte;
                     Reserved4       : Array[1..12] Of Byte
                   End; { CMosMemRec }

Const DayName     : Array[0..7] of String[9] = ('Sunday', 'Monday', 'Tuesday',
                                                'Wednesday', 'Thursday',
'Friday',
                                                'Saturday', 'Sunday');
      MonthName   : Array[0..12] of String[9] = ('???', 'January', 'February',
'March',
                                                 'April', 'May', 'June', 'July',
                                                 'August', 'September',
'October',
                                                 'November', 'December');
      ScreenName  : Array[0..3] of String[10] = ('EGA/VGA', 'CGA 40col',
                                                 'CGA 80col', 'Monochrome');
      FloppyName  : Array[0..5] of String[11] = ('none', '5.25" 360K',
                                                 '5.25" 1.2M', '3.5"  720K',
                                                 '3.5"  1.44M', '3.5"  2.88M');

Const BIOSCSeg       = $C000;
      BIOSDSeg       = $0040;
      BIOSExt        = $AA55;
      PCROMSeg       = $F000;
      ATSignature    = $FC;
      CMOSMachIDSeg  = $F000;
      CMOSMachIDOfs  = $FFFE;
      CMOSLatch      = $70;
      CMOSIOPort     = $71;
      CMOSMemorySize = 64;

Const Dells      :  Array[2..$11] of String[5] = ('200', '300', '?', '220',
'310', '325',
                                                 '?', '310A', '316', '220E',
'210',
                                                 '316SX', '316LT', '320LX', '?',
'425E');
      DellNums   : Set of 0..$FF = [2, 3, 5..7, 9..$0F, $11];

Const MouseLang  : Array[0..8] of String[10] = ('English', 'French', 'Dutch',
                                                'German', 'Swedish', 'Finnish',
                                                'Spanish', 'Portuguese',
'Italian');

Const SupportedBiosses = 119;
      BiosNames  : Array[1..SupportedBiosses] of String[20]=
                                               ('Unknown', 'Amstrad', 'Wang',
                                                'Apricot', 'Bull', 'Toshiba',
                                                'NEC', 'Texas Inst', 'Austin',
                                                'Cumulus', 'Ergo', 'Hynudai',
                                                'Nokia', 'Ogivar', 'Siemens',
                                                'Tandem', 'Tandon',
'Mitsubishi',
                                                'Matsushita', 'Sharp', 'DEC',
                                                'Hewlett Packard',
'Hewlett-Packard',
                                                'Epson', 'Leading Edge', 'NCR',
                                                'Acer', 'ALR', 'Norsk', 'Altec',
                                                'Altos', 'Televideo', 'Dell',
                                                'Commodore', 'CompuAdd',
'Gateway',
                                                'Hauppauge', 'Northgate',
'Goldstar',
                                                'Laser', 'Normerel',
'Panasonic',
                                                'Swan', 'Orange', 'Xerox',
'Zeos',
                                                'Parallan', 'Ampro', 'AT&T',
'Club',
                                                'Data General', 'Sperry',
'Unisys',
                                                'Arche', 'PC Brand', 'Elonex',
'Emerson',
                                                'DFI', 'SDI', 'AIR', 'CSS',
'Dolsh',
                                                'Mitsuba', 'Osicom', 'Polywell',
'SAI',
                                                'Micro Express', 'Packard Bell',
'PC Craft',
                                                'Headstart', 'Telex', 'Mitac',
'Everex',
                                                'DTK', 'Koyro', 'Tandy', 'Wyse',
                                                'Zenith', 'Amkly', 'AST',
'Grid', 'Cheetah',
                                                'Psion', 'US', 'Micro', 'Smith Corona',
                                                'Reply', 'Dolch', 'Aquiline',
'Comtrade',
                                                'Cardinal', 'Compudyne',
'Schmit',
                                                'Victor', 'Chicony', 'Brother', 
'Elonex',
                                                'Unknown', 'Phoenix', 'AMI',
'American Megatrends',
                                                'Award', 'DTK', 'Micronics',
'ERSO', 'Datatech',
                                                'Data Tech', 'Olivetti',
'Intel',
                                                'Seiko', 'Ultima', 'Mylex',
'Artek',
                                                'Zenith', '(C)ZDS', 'Western Digital',
                                                'Compaq', 'Monolithic', 'IBM');



Var   Regs        : Registers;
      RomInfoSeg  : Word;
      RomInfoOfs  : Word;
      DOSCOfs     : Word;
      DOSCSeg     : Word;
      DevOfs      : Word;
      DevSeg      : Word;
      CountryCode : Word;
      Country     : CountryRec;
      OsMajor     : Byte;
      OsMinor     : Byte;
      CMOS        : CMOSMemRec;
      Equip       : Word;
