uses Dos, Crt, Objects, tpString, Wizard, MkOpen, MkMsgAbs,
     MkGlobT, Misc, CTLe, Strings;

{$I RECFG146.INC}

const
 Source         : AbsMsgPtr = nil;
 Dest           : AbsMsgPtr = nil;

 stSubj         = 1;
 stDate         = 2;

 SortType       : Integer = stSubj;

type
 PMessage       = ^TMessage;
 TMessage       = object(TObject)
  date          : Longint;
  time          : Longint;
  num           : Longint;
  numO          : Longint;
  subject       : PString;
  constructor   Init(ADate, ATime, ANum: Longint; ASubject: String);
  destructor    Done; virtual;
 end;

 TBase          = object(TSortedCollection)
  function      Compare(Key1, Key2: Pointer): Integer; virtual;
 End;

 PEcho          = ^TEcho;
 TEcho          = object(TObject)
  Name          : PString;
  Path          : PString;
  constructor   Init(AName, APath: String);
  destructor    Done; virtual;
 end;

var
 Base           : TBase;
 Echos          : TCollection;
 Ini            : TControl;
 fDestination   : String;

constructor TEcho.Init;
 begin
  inherited Init;
  Name:=NewStr(AName);
  Path:=NewStr(APath);
 end;

destructor TEcho.Done;
 begin
  DisposeStr(Name);
  DisposeStr(Path);
  inherited Done;
 end;

constructor TMessage.Init;
 begin
  Inherited Init;
  Date:=ADate;
  Time:=ATime;
  Num:=ANum;
  Subject:=NewStr(ASubject);
 end;

destructor TMessage.Done;
 begin
  DisposeStr(Subject);
  Inherited Done;
 end;

function TBase.Compare;
 var
  K1, K2: PMessage;
  S1, S2: String;
 begin
  K1:=Key1; K2:=Key2;
  if SortType=stSubj then
   if K1^.Subject^<K2^.Subject^ then Compare:=-1 else
   if K1^.Subject^>K2^.Subject^ then Compare:= 1 else
    if K1^.Date<K2^.Date then Compare:=-1 else
    if K1^.Date>K2^.Date then Compare:= 1 else
     if K1^.Time<K2^.Time then Compare:=-1 else
     if K1^.Time>K2^.Time then Compare:= 1 else
      if K1^.NumO<K2^.NumO then Compare:=-1 else
      if K1^.NumO>K2^.NumO then Compare:= 1 else
       Compare:=0
  else
   if K1^.Date<K2^.Date then Compare:=-1 else
   if K1^.Date>K2^.Date then Compare:= 1 else
    if K1^.Time<K2^.Time then Compare:=-1 else
    if K1^.Time>K2^.Time then Compare:= 1 else
     if K1^.Subject^<K2^.Subject^ then Compare:=-1 else
     if K1^.Subject^>K2^.Subject^ then Compare:= 1 else
      if K1^.NumO<K2^.NumO then Compare:=-1 else
      if K1^.NumO>K2^.NumO then Compare:= 1 else
       Compare:=0;
 end;

procedure GetInfo;
 var
  Time, Date, Temp: Longint;
  S: String;
  P: PMessage;
  O: Longint;
  Y, M, D: Word;
  Mi, Ho: Word;
  DT: DateTime;
 begin
  Write('1..');
  Source^.SeekFirst(1); O:=0;
  while Source^.SeekFound do
   begin
    Inc(O);
    if MemAvail<10*1024 then
     begin
      WriteLn('There is not enought memory to complete.');
      Break;
     end;
    Source^.MsgStartUp;

    S:=Source^.GetTime;
    Str2Word(ExtractWord(1,S,[':']),Mi);
    Str2Word(ExtractWord(2,S,[':']),Ho);

    S:=Source^.GetDate;
    Str2Word(ExtractWord(2,S,['-']),D);
    Str2Word(ExtractWord(1,S,['-']),M);
    Str2Word(ExtractWord(3,S,['-']),Y);  Y:=1900+Y;

    DT.Year:=1980;
    DT.Month:=1;
    DT.Day:=1;
    DT.Hour:=Ho;
    DT.Min:=Mi;
    DT.Sec:=0;

    PackTime(DT, Time);
    Date:=JulianDay(Y,M,D);

    S:=Source^.GetSubj;
    if S[0]=#0 then S:=' ';

    P:=New(PMessage,Init(Date, Time, Source^.GetMsgNum, S));
    P^.NumO:=O;
    Base.Insert(P);

    Source^.SeekNext;
   end;
 end;

procedure WriteBase;
 procedure WriteMessage(M: PMessage); far;
  var
   TmpAddr: AddrType;
   TmpStr: String;
   PriorWrap: Boolean;
   K: Longint;
  const
   StLen = 78;
  begin
   Source^.SeekFirst(1);
   Write(Base.IndexOf(M):4,#8#8#8#8);
   for K:=1 to M^.NumO-1 do Source^.SeekNext;
   Source^.MsgStartUp;
   Dest^.StartNewMsg;
   Source^.MsgTxtStartUp;
   Source^.GetDest(TmpAddr);
   Dest^.SetDest(TmpAddr);
   Source^.GetOrig(TmpAddr);
   Dest^.SetOrig(TmpAddr);
   Dest^.SetFrom(Source^.GetFrom);
   Dest^.SetTo(Source^.GetTo);
   Dest^.SetSubj(Source^.GetSubj);
   Dest^.SetCost(Source^.GetCost);
   Dest^.SetRefer(Source^.GetRefer);
   Dest^.SetSeeAlso(Source^.GetSeeAlso);
   Dest^.SetDate(Source^.GetDate);
   Dest^.SetTime(Source^.GetTime);
   Dest^.SetLocal(Source^.IsLocal);
   Dest^.SetRcvd(Source^.IsRcvd);
   Dest^.SetPriv(Source^.IsPriv);
   Dest^.SetCrash(Source^.IsCrash);
   Dest^.SetKillSent(Source^.IsKillSent);
   Dest^.SetSent(Source^.IsSent);
   Dest^.SetFAttach(Source^.IsFAttach);
   Dest^.SetReqRct(Source^.IsReqRct);
   Dest^.SetRetRct(Source^.IsRetRct);
   Dest^.SetFileReq(Source^.IsFileReq);
   Dest^.SetEcho(False);
   PriorWrap:=Source^.WasWrap;
   TmpStr:=Source^.GetString(StLen);
   while (not Source^.EOM) or (Length(TmpStr) > 0) Do
    Begin
     if ((TmpStr[1]=#1) and (not PriorWrap)) then
      Dest^.DoKludgeLn(TmpStr)
     else
      if Source^.WasWrap then
       Dest^.DoString(TmpStr)
      else
       Dest^.DoStringLn(TmpStr);
     TmpStr:=Source^.GetString(StLen);
    end;
   Dest^.WriteMsg;
  end;
 begin
  Write(' 2..');
  Base.ForEach(@WriteMessage);
  Write('    ',#8#8#8#8);
 end;

procedure KillSource;
 var
  K: Longint;
 begin
  Write(' 3..');
  for K:=1 to Source^.NumberOfMsgs do
   begin
    Write(K:4,#8#8#8#8);
    Source^.SeekFirst(K);
    Source^.MsgStartup;
    Source^.DeleteMsg;
   end;
  Write('    ',#8#8#8#8);
 end;

procedure MoveMessages;
 var
  K: Longint;
  TmpAddr: AddrType;
  TmpStr: String;
  PriorWrap: Boolean;
 const
  StLen = 78;
 begin
  Write(' 4..');
  for K:=1 to Dest^.NumberOfMsgs do
   begin
    Write(K:4,#8#8#8#8);
    Dest^.SeekFirst(K);
    Dest^.MsgStartUp;
    Source^.StartNewMsg;
    Dest^.MsgTxtStartUp;
    Dest^.GetDest(TmpAddr);
    Source^.SetDest(TmpAddr);
    Dest^.GetOrig(TmpAddr);
    Source^.SetOrig(TmpAddr);
    Source^.SetFrom(Dest^.GetFrom);
    Source^.SetTo(Dest^.GetTo);
    Source^.SetSubj(Dest^.GetSubj);
    Source^.SetCost(Dest^.GetCost);
    Source^.SetRefer(Dest^.GetRefer);
    Source^.SetSeeAlso(Dest^.GetSeeAlso);
    Source^.SetDate(Dest^.GetDate);
    Source^.SetTime(Dest^.GetTime);
    Source^.SetLocal(Dest^.IsLocal);
    Source^.SetRcvd(Dest^.IsRcvd);
    Source^.SetPriv(Dest^.IsPriv);
    Source^.SetCrash(Dest^.IsCrash);
    Source^.SetKillSent(Dest^.IsKillSent);
    Source^.SetSent(Dest^.IsSent);
    Source^.SetFAttach(Dest^.IsFAttach);
    Source^.SetReqRct(Dest^.IsReqRct);
    Source^.SetRetRct(Dest^.IsRetRct);
    Source^.SetFileReq(Dest^.IsFileReq);
    Source^.SetEcho(False);
    PriorWrap:=Dest^.WasWrap;
    TmpStr:=Dest^.GetString(StLen);
    while (not Dest^.EOM) or (Length(TmpStr)>0) Do
     begin
      if ((TmpStr[1]=#1) and (not PriorWrap)) then
       Dest^.DoKludgeLn(TmpStr)
      else
       if Source^.WasWrap then
        Dest^.DoString(TmpStr)
       else
        Dest^.DoStringLn(TmpStr);
      TmpStr:=Dest^.GetString(StLen);
     end;
    Source^.WriteMsg;
    Dest^.DeleteMsg;
   end;
  Write('    ',#8#8#8#8);
 end;

procedure LoadEchos;
 var
  F: File;
  Config: Configuration;
  K: Longint;
  E: PEcho;
  Path: String;
  A: AreaRecord;
  St: Byte;
  M: Longint;
 begin
  {$I-} InOutRes:=0;
  Assign(F,Ini.GetParam('FastECHO.CFG','fastecho.cfg')); Reset(F,1);
  if IOResult<>0 then
   begin
    WriteLn('Cannot open FASTECHO.CFG');
    Halt(253);
   end;

  Write('Loading Fastecho''s configuration...'); M:=MemAvail;
  BlockRead(F,Config,SizeOf(Config));
  Seek(F,SizeOf(Config)+Config.Offset+Config.NodeCnt*Config.NodeRecSize);
  for K:=1 to Config.AreaCnt do
   begin
    BlockRead(F,A,SizeOf(A));
    A.Flags:=Lo(A.Flags) and not (16+32+64+128);
    Path:=StrPas(PChar(@A.Path));
    case A.Flags of
     1           : Path:='F'+AddBackSlash(Path);
     2           : Path:='S'+Path;
     3           : Path:='J'+Path;
    else
     Continue;
    end;
    E:=New(PEcho,Init(StrPas(PChar(@A.Name)),Path));
    Echos.Insert(E);
   end;
  Close(F);
  WriteLn(' done (',M-MemAvail,'b)');
 end;

function GetSortType(S: String): Integer;
 begin
  GetSortType:=stDate;
  S:=StUpcase(S);
  if S[0]=#0 then Exit;
  case S[1] of
   'D'      : GetSortType:=stDate;
   'S'      : GetSortType:=stSubj;
  end;
 end;

function FindEcho(S: String): String;
 var
  E: PEcho;
 procedure Find(Echo: PEcho); far;
  begin
   if Echo^.Name^=S then E:=Echo;
  end;
 begin
  E:=Nil;
  Echos.ForEach(@Find);
  if E=Nil then
   FindEcho:=''
  else
   FindEcho:=E^.Path^;
 end;

procedure SortEcho(Name, Path: String);
 begin
  Write(Name,' ');

  OpenMsgArea(Source,Path);
  CreateMsgArea(Dest,fDestination);
  if (Source=Nil) or (Dest=Nil) then
   begin
    WriteLn(' error! ',fdestination);
    Exit;
   end;

  Base.Init(1,1);

  GetInfo;

  WriteBase;
  KillSource;
  MoveMessages;

  Base.Done;
  CloseMsgArea(Source);
  CloseMsgArea(Dest);
  WriteLn(' ok.   ');
 end;

var
 MainSort: Integer;
 L: Longint;
 S, EchoID: String;
begin
 ClrScr;
 WriteLn('EchoSort, v1.0b, (c) by Sergey Korowkin, 1998.               Free: ',MemAvail:6,' bytes');
 WriteLn;

 Echos.Init(1,1);
 Ini.Init(ForceExtension(ParamStr(0),'CTL'),True);
 if not Ini.WasExist then
  begin
   WriteLn('Cannot open configuration file.');
   Halt(255);
  end;

 LoadEchos;

 fDestination:='J'+AddBackSlash(Ini.GetParam('Tempbase','.'))+'temp$$';

 MainSort:=GetSortType(Ini.GetParam('SortType',''));

 L:=0;
 repeat
  Inc(L);
  S:=Ini.GetMParam('Echo',L);
  if S[0]=#0 then Break;

  if WordCount(S,[' '])=1 then
   SortType:=MainSort
  else
   SortType:=GetSortType(ExtractWord(2,S,[' ']));

  EchoID:=ExtractWord(1,S,[' ']);

  S:=FindEcho(StUpcase(ExtractWord(1,S,[' '])));

  if S<>'' then SortEcho(EchoID, S);
 until 1=2;

 Ini.Done;
 Echos.Done;
end.