(*
**
** KEYBMOUSE.INC, KeyBoard and Mouse information support file
**
** Copyright (c) 1996 by Maarten Bekers
**
** Created : 29-Apr-1996
** Last update : 29-Apr-1996
**
**
*)

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function GamePortInstalled: String;
Var JSFound : Boolean;
    ScanWord: Word;
Begin;
 JsFound := False;
 Port[$201] := 01;
 If Port[$201] AND $F <> $F then
  JsFound := False
   else Repeat;
         If (Port[$201] AND $F) <> $F then
          JsFound := True;
         Inc(ScanWord);
        Until (ScanWord = $F00) or JsFound;

 If JsFound then GamePortInstalled := 'installed'
  else GamePortInstalled := '(not found)';
End; { func. GamePortInstalled }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure KeyBoardInfo;
Var Attrib: Byte;
Begin;
 Regs.AH := $12;
 Intr($16, Regs);
 Attrib := Regs.AL;
 Regs.AX := $1200 + Attrib XOR $FF;
 Intr($16, Regs);
 If Regs.AL = Attrib then
  Begin;
   Writeln('BIOS Support for enhanced keyboard: ',Bit2Str(1,0));
   Writeln('Enhanced keyboard present         : ',Bit2Str(Mem[BIOSDSeg: $0096], 
4));
  End; { if Regs.Al }

 Regs.AH:= $02;
 Intr($16, Regs);
 Writeln('Insert active                     : ',Bit2On(Regs.AL, 07));
 Writeln('Caps Lock active                  : ',Bit2On(Regs.AL, 06));
 Writeln('NumLock active                    : ',Bit2On(Regs.AL, 05));
 Writeln('ScrollLock active                 : ',Bit2On(Regs.AL, 04));
 Writeln('Keyboard Buffer starts at         : ',HexWord(BiosDSeg),':',HexWord(MemW[BiosDSeg:$0080]));
 Writeln('Keyboard Buffer ends at           : ',HexWord(BiosDSeg),':',HexWord(MemW[BiosDSeg:$0082]));
End; { proc. KeyBoardInfo }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure MouseInfo;
Var MouseVersion: Word;
Begin;
 Write('Mouse Installed                   : ');
 Regs.AX := $0021;
 Intr($33, Regs);
 If Regs.AX=$FFFF then
  Begin;
    If Regs.BX = $FFFF then Regs.BX := 02;
    Writeln(Bit2Str(1,0));
    Writeln('Buttons                           : ',Regs.BX);
    Regs.AX := $0070;
    Regs.BX := $ABCD;
    Intr($33, Regs);
    If (Regs.AX=$ABCD) AND (MemW[Regs.BX:Regs.CX]=$ABCD) AND
     (MemW[Regs.BX:Regs.CX + 08] = $ABCD) then
      Begin;
       MouseVersion := MemW[MemW[Regs.BX:Regs.CX+04]: MemW[Regs.BX:Regs.CX+02]];
       Writeln('Mouse systems version             : ',Hi(MouseVersion),'.',
Lo(MouseVersion));
      End; { If MouseSystems }

    Regs.AX := $266C;
    Regs.BX := 0;
    Regs.CX := 0;
    Intr($33, Regs);
    If Regs.BX = $5353 then
      Writeln('Logitech version                  : ',Chr(Regs.CH),'.',
Chr(Regs.CL),'x');

    Write  ('Microsoft version standard        : ');
    Regs.AX := $0024;
    Intr($33, Regs);
    If Regs.AX < $FFFF then
     Begin;
      Writeln(Regs.BH, '.', UnBcd(Regs.BL));
      Write('Mouse Type                        : ');
      Case Regs.CH of
       $01 : Writeln('Bus');
       $02 : Writeln('Serial');
       $03 : Writeln('InPort');
       $04 : Writeln('PS/2');
       $05 : Writeln('HP');
        else Writeln('Unknown?');
       End; { Regs.AX }
       
      Write('Interrupt number                  : ');
      Case Regs.CL of
       $00           : Writeln('PS/2 (unknown)');
       $02..$05, $07 : Writeln('IRQ', Regs.CL);
        else Writeln('(unknown)');
      End; { Case }

      Write('EGA register services support     : ');
      Regs.AH := $FA;
      Regs.BX := 00;
      Intr($10, Regs);
      If Regs.BX <> 00 then
        Writeln(Bit2Str(1,0))
         else Writeln(Bit2Str(0,0));

      Write('Language of mouse driver          : ');
      Regs.AX := $0023;
      Intr($33, Regs);
      If Regs.AX < $FFFF then
      If Regs.BX < 9 then
      Writeln(MouseLang[Regs.BX])
       else Writeln('Unknown language')
        else Writeln('N/A');
     End { IF Ax }
      else Writeln('(unknown)');
    End
     else Writeln(Bit2Str(0,0));                         { No mouse detected }
End; { proc. MouseInfo }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure ShowInputInfo;
Begin;
 KeyBoardInfo;
 Writeln('Gameport installed                : ',GamePortInstalled);
 MouseInfo;
End; { proc. ShowInputInfo }
